#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

typedef float tip;

struct bod {
  tip x, y, z;
};

struct vektor {
  tip x, y, z;
};

struct objekt {
  bod A;
  vektor v;
  tip m;
};

struct koule:objekt {
  tip r;

  koule(void) {
	bod P;
	vektor e;
	P.x = 0; P.y = 0; P.z = 0;
	e.x = 0; e.y = 0; e.z = 0;
	koule(P, e, 0, 0);
  }

  koule(bod Ai, vektor vi, tip mi, tip ri) {
	A = Ai;
	v = vi;
	m = mi;
	r = ri;
  }

  void move(void) {
	A.x += v.x;
	A.y += v.y;
	A.z += v.z;
  }

  void paint(void) {
	setcolor(15);
	circle(A.x, A.y, r);
//	fillellipse(A.x, A.y, r, r);
  }

  void erase(void) {
	setcolor(0);
//	fillellipse(A.x, A.y, r, r);
	circle(A.x, A.y, r);
  }

};

int inarea(koule f, koule s) {
  tip min;
  vektor q;
  q.x = f.A.x + f.v.x - s.A.x - s.v.x;
  q.y = f.A.y + f.v.y - s.A.y - s.v.y;
  q.z = f.A.z + f.v.z - s.A.z - s.v.z;
  min = (f.r + s.r);
  if ((q.x < min)&&(q.y < min)&&(q.z < min)) {
	tip d = sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
	if ((d < min)&&(d > (min-1))) return(1);
	else return(0);
  }
  else return(0);
}

void odraz(koule *f, koule *s) {
  bod A, B;
  vektor q, v, w;
  tip c, hv, hw, m1, m2, Rv, Rw;

  A = (*f).A;
  B = (*s).A;
  v.x = (*f).v.x*0.8;
  v.y = (*f).v.y*0.8;
  v.z = (*f).v.z*0.8;
  w.x = (*s).v.x*0.8;
  w.y = (*s).v.y*0.8;
  w.z = (*s).v.z*0.8;
  m1 = (*f).m;
  m2 = (*s).m;

  q.x = A.x - B.x;
  q.y = A.y - B.y;
  q.z = A.z - B.z;

  tip t, vq, Kv, Kvn, Kw, Kwn;
  vektor nv, nw;

  vq = sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
  t = (v.x*q.x + v.y*q.y + v.z*q.z)/(q.x*q.x + q.y*q.y + q.z*q.z);

  nv.x = v.x - q.x*t;
  nv.y = v.y - q.y*t;
  nv.z = v.z - q.z*t;
  Kv = vq*t;

  t = (w.x*q.x + w.y*q.y + w.z*q.z)/(q.x*q.x + q.y*q.y + q.z*q.z);
  nw.x = w.x - q.x*t;
  nw.y = w.y - q.y*t;
  nw.z = w.z - q.z*t;
  Kw = vq*t;

  Kvn = ( (m1 - m2)*Kv + 2*m2*Kw )/( m1 + m2 );
  Kwn = ( (m2 - m1)*Kw + 2*m1*Kv )/( m1 + m2 );

  q.x = q.x / vq;
  q.y = q.y / vq;
  q.z = q.z / vq;

  (*f).v.x = Kvn*q.x + nv.x;
  (*f).v.y = Kvn*q.y + nv.y;
  (*f).v.z = Kvn*q.z + nv.z;

  (*s).v.x = Kwn*q.x + nw.x;
  (*s).v.y = Kwn*q.y + nw.y;
  (*s).v.z = Kwn*q.z + nw.z;

/*
  c = 1/( (m1 + m2)*(q.x*q.x + q.y*q.y + q.z*q.z) ) ;
  hv = v.x*q.x + v.y*q.y + v.z*q.z;
  hw = w.x*q.x + w.y*q.y + w.z*q.z;

  Rv = (hv*(m1 - m2 - 1) + 2*m2*hw)*c;
  Rw = (hw*(m2 - m1 - 1) + 2*m1*hv)*c;

  (*f).v.x += q.x*Rv;
  (*f).v.y += q.y*Rv;
  (*f).v.z += q.z*Rv;

  (*s).v.x += q.x*Rw;
  (*s).v.y += q.y*Rw;
  (*s).v.z += q.z*Rw;
*/
}

#define POC 2
#define MAXX 600
#define MAXY 400


void okraj(koule *k) {
  if ((*k).A.x < 10) {
	(*k).v.x *= -0.8;
	(*k).A.x = 10;
  }
  if ((*k).A.y < 10) {
	(*k).v.y *= -0.8;
	(*k).A.y = 10;
  }
  if ((*k).A.x > MAXX) {
	(*k).v.x *= -0.8;
	(*k).A.x = MAXX;
  }
  if ((*k).A.y > MAXY) {
	(*k).v.y *= -0.8;
	(*k).A.y = MAXY;
  }
}

void main(void) {
int gd = 0, gm = 0;
initgraph(&gd, &gm, "../bgi");

koule k[POC];

char c = 0;
int i = 0, j = 0;

randomize();
for (i = 0; i < POC; i ++) {
  k[i].A.x = random(MAXX);
  k[i].A.y = random(MAXY);
  k[i].A.z = random(MAXY);
  k[i].v.x = (tip)(random(100)-50)/200;
  k[i].v.y = (tip)(random(100)-50)/200;
  k[i].v.z = (tip)(random(100)-50)/200;
  k[i].r = random(40);
  k[i].m = k[i].r;
}

  k[0].A.x = 400;
  k[0].A.y = 200;
  k[0].A.z = 0;
  k[0].v.x = -0.5;
  k[0].v.y = 0.1;
  k[0].v.z = 0;
  k[0].r = 40;
  k[0].m = k[i].r;

  k[1].A.x = 100;
  k[1].A.y = 200;
  k[1].A.z = 0;
  k[1].v.x = 0.1;
  k[1].v.y = 0;
  k[1].v.z = 0.1;
  k[1].r = 40;
  k[1].m = k[i].r;


while (c != 27) {
  for (i = 0; i < POC; i ++) {
	k[i].erase();
//	okraj(&k[i]);
	k[i].move();
	k[i].paint();
	for (j = 0; j < POC; j ++) {
	  if (i != j) {
//		k[i].v.x += (k[j].A.x - k[i].A.x)*0.000001*k[j].m;
//		k[i].v.y += (k[j].A.y - k[i].A.y)*0.000001*k[j].m;
//		k[i].v.z += (k[j].A.z - k[i].A.z)*0.000001*k[j].m;
		if (inarea(k[i], k[j])) odraz(&k[i], &k[j]);
	  }
	}
  }
  if (kbhit()) c = getch();
  if (c == 13) {
	c = 0;
	cleardevice();
	for (i = 0; i < POC; i ++) {
	  k[i].A.x = random(MAXX);
	  k[i].A.y = random(MAXY);
	  k[i].A.z = random(MAXY);
	  k[i].v.x = (tip)(random(100)-50)/200;
	  k[i].v.y = (tip)(random(100)-50)/200;
	  k[i].v.z = (tip)(random(100)-50)/200;
//	  k[i].v.x = 0;
//	  k[i].v.y = 0;
//	  k[i].v.z = 0;
	  k[i].r = random(40);
	  k[i].m = k[i].r;
	}
  }
  delay(5);
}



closegraph();
}
